#include <linux/stddef.h>
#include <sys/types.h>
#include <linux/videodev2.h>
#include <rockchip/rockchip_drm.h>

#define BUF_COUNT	4

typedef enum _CAM_TYPE {
	CAM_TYPE_USB,
	CAM_TYPE_MIPI,
	CAM_TYPE_HDMIRX,
} CAM_TYPE;

class v4l2_camera {
public:
	v4l2_camera(int dev, CAM_TYPE type, __u32 width, __u32 height, bool is_cmabuffer);
	~v4l2_camera(void);
	int start(void);
	DrmBuffer *get_frame(void);
private:
	int m_dev;
	int drm_fd, v4l2_fd;
	__u32 m_width;
	__u32 m_height;
	__u32 m_format;

	DrmBuffer *buffers[BUF_COUNT];
	bool m_cmabuffer;
	int n_buffer;
	int m_current;

	__u32 m_memory;
	enum v4l2_buf_type m_type;
	bool m_hasplane;

	bool m_streamon;
};
